//Simple VGA Driver test

#include "Platform.h"



//Simple VGA Driver 640x480x8bpp that shows embedded image
struct __using("VGA_SimpleDriver1a.spin2") vga; //RJA:  Visual Studio will show an error here, but it's OK

int nLoop;
char* pbmp;
int sbmp;

void MountSD()
{
    int r = 0;
    _umount("/sd"); //have to unmount to get 0 from mount
#ifndef USE_SDIO
    r = mount("/sd", _vfs_open_sdcardx(PIN_CLK, PIN_SS, PIN_MOSI, PIN_MISO));
#else
    r = mount("/sd", _vfs_open_sdsdcard(CLK_DIV, PIN_CLK, PIN_CMD, PIN_DAT0, PIN_CD, PIN_RED));
#endif // !USE_SDIO

    
    if (r != 0) {
        printf("ERROR: got error %d during mount\n", r);
        for (;;) {}
    }
}

void Setup()
{
    vga.start(VGA_BASEPIN);
    printf("VGA Driver started.\n");
    MountSD();
    printf("uSD Mounted.\n");

    pbmp = vga.GetBmpAddress();
    sbmp = vga.GetBmpSize();

    //power cycle and init uSD
    _pinh(PIN_PWR);
    _waitms(10);
    _pinl(PIN_PWR);
    _waitms(1);
    MountSD();
    chdir("/sd");

}

void Loop()
{
    nLoop++;
    printf("Loading bmp image from uSD.\n");
    FILE* f;
    f = fopen("benji.bmp", "rb");
    if (!f) {
        printf(" fopen() failed! \n");
        while (1) {}
    }

    int tmr = _getus();
    fread(pbmp, 1, sbmp, f);
    fclose(f);
    tmr = _getus() - tmr;
    int count = sbmp / 1024;
    printf(" Read %d kB at %d kB/s, ", count, _muldiv64(count, 1_000_000, tmr));
}

int main()
{
 
    nLoop = 0;
    char c=0;
    printf("Starting\n");

    Setup();

    for (;;)
    {
        Loop();
    }

}
